Qwt User's Guide 6.1.6

Public Types | Public Member Functions | Protected Member Functions | List of all members
QwtPlotSpectroCurve Class Reference

Curve that displays 3D points as dots, where the z coordinate is mapped to a color. More...

`#include <qwt_plot_spectrocurve.h>`

Inheritance diagram for QwtPlotSpectroCurve:
[legend]

## Public Types
enum | PaintAttribute { ClipPoints = 1 }
| Paint attributes. More...
typedef QFlags< PaintAttribute > | PaintAttributes
| Paint attributes.
Public Types inherited from QwtPlotItem
enum | RttiValues { Rtti_PlotItem = 0, Rtti_PlotGrid, Rtti_PlotScale, Rtti_PlotLegend, Rtti_PlotMarker, Rtti_PlotCurve, Rtti_PlotSpectroCurve, Rtti_PlotIntervalCurve, Rtti_PlotHistogram, Rtti_PlotSpectrogram, Rtti_PlotSVG, Rtti_PlotTradingCurve, Rtti_PlotBarChart, Rtti_PlotMultiBarChart, Rtti_PlotShape, Rtti_PlotTextLabel, Rtti_PlotZone, Rtti_PlotUserItem = 1000 }
| Runtime type information. More...
enum | ItemAttribute { Legend = 0x01, AutoScale = 0x02, Margins = 0x04 }
| Plot Item Attributes. More...
enum | ItemInterest { ScaleInterest = 0x01, LegendInterest = 0x02 }
| Plot Item Interests. More...
enum | RenderHint { RenderAntialiased = 0x1 }
| Render hints. More...
typedef QFlags< ItemAttribute > | ItemAttributes
| Plot Item Attributes.
typedef QFlags< ItemInterest > | ItemInterests
| Plot Item Interests.
typedef QFlags< RenderHint > | RenderHints
| Render hints.

## Public Member Functions
| QwtPlotSpectroCurve (const QString &title=QString())
| QwtPlotSpectroCurve (const QwtText &title)
virtual | ~QwtPlotSpectroCurve ()
| Destructor.
virtual int | rtti () const
void | setPaintAttribute (PaintAttribute, bool on=true)
bool | testPaintAttribute (PaintAttribute) const
void | setSamples (const QVector< QwtPoint3D > &)
void | setSamples (QwtSeriesData< QwtPoint3D > *)
void | setColorMap (QwtColorMap *)
const QwtColorMap * | colorMap () const
void | setColorRange (const QwtInterval &)
QwtInterval & | colorRange () const
virtual void | drawSeries (QPainter *, const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRectF &canvasRect, int from, int to) const
void | setPenWidth (double)
double | penWidth () const
Public Member Functions inherited from QwtPlotSeriesItem
| QwtPlotSeriesItem (const QString &title=QString())
| QwtPlotSeriesItem (const QwtText &title)
virtual | ~QwtPlotSeriesItem ()
| Destructor.
void | setOrientation (Qt::Orientation)
Qt::Orientation | orientation () const
virtual void | draw (QPainter *, const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRectF &) const
| Draw the complete series. More...
virtual QRectF | boundingRect () const
virtual void | updateScaleDiv (const QwtScaleDiv &, const QwtScaleDiv &)
| Update the item to changes of the axes scale division. More...
Public Member Functions inherited from QwtPlotItem
| QwtPlotItem (const QwtText &title=QwtText())
virtual | ~QwtPlotItem ()
| Destroy the QwtPlotItem.
void | attach (QwtPlot *plot)
| Attach the item to a plot. More...
void | detach ()
| This method detaches a QwtPlotItem from any QwtPlot it has been associated with. More...
QwtPlot * | plot () const
| Return attached plot.
void | setTitle (const QString &title)
void | setTitle (const QwtText &title)
const QwtText & | title () const
void | setItemAttribute (ItemAttribute, bool on=true)
bool | testItemAttribute (ItemAttribute) const
void | setItemInterest (ItemInterest, bool on=true)
bool | testItemInterest (ItemInterest) const
void | setRenderHint (RenderHint, bool on=true)
bool | testRenderHint (RenderHint) const
void | setRenderThreadCount (uint numThreads)
uint | renderThreadCount () const
void | setLegendIconSize (const QSize &)
QSize | legendIconSize () const
double | z () const
void | setZ (double z)
| Set the z value. More...
void | show ()
| Show the item.
void | hide ()
| Hide the item.
virtual void | setVisible (bool)
bool | isVisible () const
void | setAxes (int xAxis, int yAxis)
void | setXAxis (int axis)
int | xAxis () const
| Return xAxis.
void | setYAxis (int axis)
int | yAxis () const
| Return yAxis.
virtual void | itemChanged ()
virtual void | legendChanged ()
virtual void | getCanvasMarginHint (const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRectF &canvasRect, double &left, double &top, double &right, double &bottom) const
| Calculate a hint for the canvas margin. More...
virtual void | updateLegend (const QwtPlotItem *, const QList< QwtLegendData > &)
| Update the item to changes of the legend info. More...
QRectF | scaleRect (const QwtScaleMap &, const QwtScaleMap &) const
| Calculate the bounding scale rectangle of 2 maps. More...
QRectF | paintRect (const QwtScaleMap &, const QwtScaleMap &) const
| Calculate the bounding paint rectangle of 2 maps. More...
virtual QList< QwtLegendData > | legendData () const
| Return all information, that is needed to represent the item on the legend. More...
virtual QwtGraphic | legendIcon (int index, const QSizeF &) const
Public Member Functions inherited from QwtSeriesStore< QwtPoint3D >
| QwtSeriesStore ()
| Constructor The store contains no series.
| ~QwtSeriesStore ()
| Destructor.
void | setData (QwtSeriesData< QwtPoint3D > *series)
QwtSeriesData< QwtPoint3D > * | data ()
const QwtSeriesData< QwtPoint3D > * | data () const
QwtPoint3D | sample (int index) const
virtual size_t | dataSize () const
virtual QRectF | dataRect () const
virtual void | setRectOfInterest (const QRectF &rect)
QwtSeriesData< QwtPoint3D > * | swapData (QwtSeriesData< QwtPoint3D > *series)

## Protected Member Functions
virtual void | drawDots (QPainter *, const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRectF &canvasRect, int from, int to) const
Protected Member Functions inherited from QwtPlotSeriesItem
virtual void | dataChanged ()
| dataChanged() indicates, that the series has been changed.
Protected Member Functions inherited from QwtPlotItem
QwtGraphic | defaultIcon (const QBrush &, const QSizeF &) const
| Return a default icon from a brush. More...
Protected Member Functions inherited from QwtAbstractSeriesStore
virtual | ~QwtAbstractSeriesStore ()
| Destructor.
virtual QRectF | dataRect () const =0
virtual size_t | dataSize () const =0

## Detailed Description

Curve that displays 3D points as dots, where the z coordinate is mapped to a color.

## Member Enumeration Documentation

## ◆ PaintAttribute

enum QwtPlotSpectroCurve::PaintAttribute

Paint attributes.

Enumerator
ClipPoints | Clip points outside the canvas rectangle.

## Constructor & Destructor Documentation

## ◆ QwtPlotSpectroCurve() [1/2]

QwtPlotSpectroCurve::QwtPlotSpectroCurve | ( | const QString & | title = `QString()` | ) |
| explicit

Constructor

Parameters

  title | Title of the curve

## ◆ QwtPlotSpectroCurve() [2/2]

QwtPlotSpectroCurve::QwtPlotSpectroCurve | ( | const QwtText & | title | ) |
| explicit

Constructor

Parameters

  title | Title of the curve

## Member Function Documentation

## ◆ colorMap()

const QwtColorMap * QwtPlotSpectroCurve::colorMap | ( |  | ) | const

Returns
  Color Map used for mapping the intensity values to colors

See also
  setColorMap(), setColorRange(), QwtColorMap::color()

## ◆ colorRange()

QwtInterval & QwtPlotSpectroCurve::colorRange | ( |  | ) | const

Returns
  Value interval, that corresponds to the color map

See also
  setColorRange(), setColorMap(), QwtColorMap::color()

## ◆ drawDots()

void QwtPlotSpectroCurve::drawDots | ( | QPainter * | painter,
|  | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | const QRectF & | canvasRect,
|  | int | from,
|  | int | to
| ) |  | const
| protected virtual

Draw a subset of the points

Parameters

  painter | Painter
  xMap | Maps x-values into pixel coordinates.
  yMap | Maps y-values into pixel coordinates.
  canvasRect | Contents rectangle of the canvas
  from | Index of the first sample to be painted
  to | Index of the last sample to be painted. If to < 0 the series will be painted to its last sample.

See also
  drawSeries()

## ◆ drawSeries()

void QwtPlotSpectroCurve::drawSeries | ( | QPainter * | painter,
|  | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | const QRectF & | canvasRect,
|  | int | from,
|  | int | to
| ) |  | const
| virtual

Draw a subset of the points

Parameters

  painter | Painter
  xMap | Maps x-values into pixel coordinates.
  yMap | Maps y-values into pixel coordinates.
  canvasRect | Contents rectangle of the canvas
  from | Index of the first sample to be painted
  to | Index of the last sample to be painted. If to < 0 the series will be painted to its last sample.

See also
  drawDots()

Implements QwtPlotSeriesItem.

## ◆ penWidth()

double QwtPlotSpectroCurve::penWidth | ( |  | ) | const

Returns
  Pen width used to draw a dot

See also
  setPenWidth()

## ◆ rtti()

int QwtPlotSpectroCurve::rtti | ( |  | ) | const
| virtual

Returns
  QwtPlotItem::Rtti_PlotSpectroCurve

Reimplemented from QwtPlotItem.

## ◆ setColorMap()

void QwtPlotSpectroCurve::setColorMap | ( | QwtColorMap * | colorMap | ) |

Change the color map

Often it is useful to display the mapping between intensities and colors as an additional plot axis, showing a color bar.

Parameters

  colorMap | Color Map

See also
  colorMap(), setColorRange(), QwtColorMap::color(), QwtScaleWidget::setColorBarEnabled(), QwtScaleWidget::setColorMap()

## ◆ setColorRange()

void QwtPlotSpectroCurve::setColorRange | ( | const QwtInterval & | interval | ) |

Set the value interval, that corresponds to the color map

Parameters

  interval | interval.minValue() corresponds to 0.0, interval.maxValue() to 1.0 on the color map.

See also
  colorRange(), setColorMap(), QwtColorMap::color()

## ◆ setPaintAttribute()

void QwtPlotSpectroCurve::setPaintAttribute | ( | PaintAttribute | attribute,
|  | bool | on = `true`
| ) |  |

Specify an attribute how to draw the curve

Parameters

  attribute | Paint attribute
  on | On/Off /sa PaintAttribute, testPaintAttribute()

## ◆ setPenWidth()

void QwtPlotSpectroCurve::setPenWidth | ( | double | penWidth | ) |

Assign a pen width

Parameters

  penWidth | New pen width

See also
  penWidth()

## ◆ setSamples() [1/2]

void QwtPlotSpectroCurve::setSamples | ( | const QVector< QwtPoint3D > & | samples | ) |

Initialize data with an array of samples.

Parameters

  samples | Vector of points

## ◆ setSamples() [2/2]

void QwtPlotSpectroCurve::setSamples | ( | QwtSeriesData< QwtPoint3D > * | data | ) |

Assign a series of samples

setSamples() is just a wrapper for setData() without any additional value - beside that it is easier to find for the developer.

Parameters

  data | Data

Warning
  The item takes ownership of the data object, deleting it when its not used anymore.

## ◆ testPaintAttribute()

bool QwtPlotSpectroCurve::testPaintAttribute | ( | PaintAttribute | attribute | ) | const

Returns
  True, when attribute is enabled

See also
  PaintAttribute, setPaintAttribute()